package RPM::Source::Dependency::Analyzer::Collector::Parser::QMake;

use strict;
use warnings;

use RPM::Source::Dependency::Analyzer::Collector::Parser;

our @ISA=qw/RPM::Source::Dependency::Analyzer::Collector::Parser/;
our $verbose=0;
our $VERSION=0.001;

sub parse_string {
    my ($self,$data)=@_;
    $data=~s/\\\n//gs;
    foreach my $line (split("\n",$data)) {
	&_parse_line($self,$line);
    }
    my $hook=$self->{-postfilehook};
    &$hook($self) if $hook;
}

sub _parse_line {
    my ($self,$line)=@_;
    $line=~s/^\s*//;
    $line=~s/\s*$//;
    if ($line=~/([\w_][\w\d_]*)\s*\+?=\s*(.*)$/) {
	$self->add_var($1,$2);
    }
}

sub add_var {
    my ($self,$name,$val)=@_;
    print STDERR "VAR: add $name=$val\n" if $verbose>1;
    my $hook=$self->{-varhook};
    &$hook($name,$val,$self) if $hook;
    return $val;
}



1;
