package RPM::Source::Dependency::Analyzer::Collector::PkgDB;

use Carp;
use strict;
use warnings;

our $verbose=0;

## TODO; make it truly
## distodb destinfo dependent!!!

my %NAMEPKG=(
    'cxx' => ['gcc-c++'],

    'java' => ['rpm-build-java','java-devel-default'],
    'openmp' => ['openmpi-devel'],
    'perl' => ['rpm-build-perl','perl-devel'],
    'python2' => ['rpm-build-python','python-devel'],
    'python' => ['rpm-build-python3','python3-devel'],
    'qt3' => ['libqt3-devel'],
    'qt4' => ['libqt4-devel'],
    'qt5' => ['libqt5-devel'],
    'ruby' => ['rpm-build-ruby','libruby-devel'],
    ### hack!!! clients have to determine more details...
    'wxWidgets' => ['libwxGTK-devel'],
# approx, not tested
    'kde3' => ['gcc-c++','kdelibs-devel'],
    'kde4' => ['gcc-c++','kde4libs-devel'],
    'kf5' => ['gcc-c++','rpm-build-kf5'],
    );

sub db_add_environment {
    my $storage=shift;
    die 'Oops! storage is expected' unless ref $storage;
    die 'Oops! args are expected' unless @_>0;
    foreach my $envname (@_) {
	my $pkg=$NAMEPKG{$envname};
	if ($pkg) {
	    $storage->add_pkgs_req(ref ($pkg) ? @$pkg: $pkg);
	    print STDERR "DEBUG: Collector::PkgDB: env $envname: added ",
		(ref ($pkg) ? join(',',@$pkg): $pkg),"\n" if $verbose;
	} else {
	    Carp::carp "WARNING: DependencyAnalyzer: db_add_environment: not found: $envname";
	}
    }
}
