package RPM::Source::Dependency::Analyzer::Collector::Plugin::Python;

use strict;
use warnings;

our @ISA=qw/RPM::Source::Dependency::Analyzer::Collector::Parser/;

our $verbose=0;

# TODO
# PEP 420 -- Implicit Namespace Packages
#https://www.python.org/dev/peps/pep-0420/

sub parse_string {
    my ($self,$data)=@_;
    #$data=~s/\\\n//gs;
    foreach my $line (split("\n",$data)) {
	&_parse_line($self,$line);
    }
}

sub _parse_line {
    my ($self,$line)=@_;
    #$line=~s/^\s*//;
    #$line=~s/\s*$//;
    if ($line=~/^\s*from\s*(\S+)/) {
	$self->add_import($1);
    } elsif ($line=~/^\s*import\s*(\S.*)$/) {
	my $import_args=$1;
	$import_args=~s/[;\s]*$//;
	my @attrs=split(/\s*,\s*/, $import_args);
	foreach my $attr (@attrs) {
	    if ($attr=~/(.+)\.[^\.]+$/) {
		$self->add_import($1);
	    } else {
		$self->add_import($attr);
	    }
	}
    }
}

sub add_import {
    my ($self,$name)=@_;
    print STDERR "Collector::Plugin::Python: add $name\n" if $verbose>1;
    $self->{-storage}->add_python_req( $name );
    return;
}

1;
