package RPM::Source::Dependency::Analyzer::Collector::Plugin::Ruby;

use strict;
use warnings;

use RPM::Source::Dependency::Analyzer::Collector::Parser;
our @ISA=qw/RPM::Source::Dependency::Analyzer::Collector::Parser/;

our $verbose=0;
our $VERSION=0.001;

sub parse_string {
    my ($self,$data)=@_;
    #$data=~s/\\\n//gs;
    foreach my $line (split("\n",$data)) {
	&_parse_line($self,$line);
    }
}

sub _parse_line {
    my ($self,$line)=@_;
    #$line=~s/^\s*//;
    #$line=~s/\s*$//;

    # note: check only require and load. 
    # require_relative does not add external dependencies (file is at hand).
    if ($line=~/^\s*require\s*['"]([^'"]+)['"]\s*$/) {
	$self->add_ruby($1);
    } elsif ($line=~/\brequire\b/) {
	print STDERR "DEBUG: Dependency::Analyzer: Ruby: can be require: $line\n" if $verbose>1;
    } elsif ($line=~/^\s*load\s*['"]([^'"]+)['"]\s*$/) {
	$self->add_ruby($1);
    } elsif ($line=~/\bload\b/) {
	print STDERR "DEBUG: Dependency::Analyzer: Ruby: can be load: $line\n" if $verbose>1;
    }
}


sub add_ruby {
    my ($self, $name)=@_;
    return if $name=~/\.jar$/;
    print "_ruby_handler: $name\n" if $verbose;
    $self->{-storage}->add_ruby_req( &__ruby($name) );
}

# TODO: prototype: copypasted with autoconf
sub __ruby {
    local $_;
    $_=$_[0];
    s/\.rb$//;
    return $_;
}



1;
