package RPM::Source::Dependency::Analyzer::PerlUtils;

use strict;
use warnings;

require Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw(_perl_pkg2dep _perl_req2dep _perl_expr2dep);

sub _perl_pkg2dep {
    my $dep="perl($_[0].pm)";
    $dep=~s!::!/!g;
    return $dep;
}
sub _perl_req2dep {
    my $dep="perl($_[0])";
    return $dep;
}

sub _perl_expr2dep {
    my $arg=shift;
    if ($arg=~m!^perl\((.*\.p[mhl])\)$!) {
	return $arg;
    } elsif ($arg=~m!\.p[mhl]$!) {
	return &_perl_req2dep($arg);
    } elsif ((-1 != index($arg,'/')) and (-1 == index($arg,'::'))) {
	# Foo/Bar
	return &_perl_req2dep($arg.'.pm');
    } else {
	return &_perl_pkg2dep($arg);
    }
}

1;
