package RPM::Source::Dependency::Analyzer::Resolver::PathResolver;

use strict;
use warnings;
use Carp;

use RPM::Source::Dependency::Analyzer::Resolver::SingleType;
our @ISA=qw/RPM::Source::Dependency::Analyzer::Resolver::SingleType/;

our $verbose=0;

sub _map_and_resolve {
    my ($self,$candidate)=@_;
    my $db=$self->get_distrodbname;

    foreach my $prefix (qw!/bin/ /sbin/!) {
	my $file=$prefix.$candidate;
	my @data=$self->_distrodb_translate('bin',$file);
	return \@data, $file if @data;
    }
    foreach my $prefix (qw!/usr/bin/ /usr/sbin/!) {
	my $file=$prefix.$candidate;
	my @data=$self->_distrodb_translate('bin',$file);
	# for alternatives in /usr/bin
	@data=$self->_distrodb_translate('provides',$file) unless @data;
	return \@data, $file if @data;
    }
    return [], undef;
}

## TODO hack ##################
# /bin utilities are considered as always present (basesytem)
sub _postprocess {
    my ($self,$dataref,$mapped_nameref)=@_;
    # if nothing found
    return unless defined($$mapped_nameref);
    if ($$mapped_nameref=~m!^/s?bin/!) {
	@$dataref='coreutils'; # /bin utilities hack
	$$mapped_nameref='coreutils'; # /bin utilities hack
    }
}
################################

1;

__END__
