package RPM::Source::Dependency::Analyzer::Resolver::PythonResolver;

use strict;
use warnings;
use Carp;

use RPM::Source::Dependency::Analyzer::Resolver::SingleType;
our @ISA=qw/RPM::Source::Dependency::Analyzer::Resolver::SingleType/;

our $verbose=0;

my $python2='python2.7';
my $python3='python3';

my (%PYTHON_IGNORE,%PYTHON_DROP);
my %PYTHON_MAP_ALWAYS = map {$_=>1} qw/
python python-base python-dev python-devel python-modules
python3 python3-base python3-dev python3-devel
/;

sub new {
    my ($class)=shift;
    my $self=$class->SUPER::new(
	-map_always => \%PYTHON_MAP_ALWAYS,
	-IGNORE_NOT_FOUND_hash => \%PYTHON_IGNORE,
	-DROP_hash => \%PYTHON_DROP,
	@_);
    $self->{-mappable_optsuffix} = 'python';
    $self->{-is_mappable} = 1;
    my $target=$self->get_distrodbname;
    if (!$target or $target eq 'python3') {
	$self->{-mapper} = sub { return $python3."($_[0])"};
    } elsif ($target eq 'python2') {
	$self->{-mapper} = sub { return $python2."($_[0])"};
    } else {
	die "Oops: strange target: ",$target;
    }
    return $self;
}


1;

__END__
