package RPM::Source::Dependency::Analyzer::Sourcedep::Resolver;
use strict;
use warnings;
use Carp;

use Source::Shared::Resource::DestDistroInfo;
use RPM::Source::Tools::BuildReqStorage 0.101;
use RPM::Source::Dependency::Analyzer::Storage;
use RPM::Source::Dependency::Analyzer::Resolver;
use RPM::Source::Dependency::Analyzer::Sourcedep::Commandline;

$Source::Shared::Resource::DestDistroInfo::opt_check_distrodb=3;

our $VERSION=0.002;
our $verbose=0;
my $resolver;
my $distroinfo;

sub resolve_sourcedep {
    my ($cmd,@argv)=@_;
    return unless @argv;
    $distroinfo//=&Source::Shared::Resource::DestDistroInfo::get_dest_distroinfo();
    my $storage=RPM::Source::Dependency::Analyzer::Storage->new();
    my $status=&RPM::Source::Dependency::Analyzer::Sourcedep::Commandline::process_argv($distroinfo,$storage,$cmd,@argv);
    return 0 unless $status;
    $resolver//=RPM::Source::Dependency::Analyzer::Resolver->new(-verbose => $verbose);
    my $buildreq=RPM::Source::Tools::BuildReqStorage->new();
    $resolver->resolve(
	-allow_unknown_python => 0,
	-keep_explicit_python => 0,
	-resolve_pkgconfig => 1,
	-allow_unknown_pkgconfig => 0,
	-keep_explicit_pkgconfig => 0,
	-resolve_perl => 1,
	-allow_unknown_perl => 0,
	-keep_explicit_perl => 0,
	-resolve_path => 1,
	-allow_unknown_path => 0,
	-keep_explicit_path => 0,

	-disable_postresolve => 1,
	-verbose => $verbose,
	-storage => $storage,
	-distroinfo=> $distroinfo,
	-buildreq => $buildreq,
	);
    # we ignore buildreq_pre as they are alt specific
    my @resolved=$buildreq->get_list_buildreq;
    return 1,\@resolved;
}

1;
