package RPM::Source::Transformation::Factory::DependencyAnalyzer::Resolver;

use strict;
use warnings;
use Carp;

use RPM::Source::Dependency::Analyzer::Resolver;
use Source::Shared::Resource::DestDistroInfo;
use RPM::Source::Transformation::Resource::Buildreq;
use RPM::Source::Transformation::Resource::DependencyAnalyzer::Storage;
use RPM::Source::Transformation::Factory;

our @ISA=qw/RPM::Source::Transformation::Factory/;

push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

$Source::Shared::Resource::DestDistroInfo::opt_check_distrodb=7; # days

our $verbose=1;

sub cli_container_ref {
    return ['RPM::Source::Dependency::Analyzer::Resolver'];
}

sub transformations {
    return RPM::Source::Transformation::OptHandlerWrapper->new(
	-priority => PRIORITY_POSTCONVERT,
	-name => 'sourcedep2buildreq',
	-opt_handler_sub=>\&opt_handler);
}

sub opt_handler {
    my (undef,$spec,undef,$opt,$resourceobj)=@_;
    my $storage=$resourceobj->{'__DependencyAnalyzerStorage'};
    if ($storage) {
	my $resolver=RPM::Source::Dependency::Analyzer::Resolver->new();
	$resolver->resolve(
#	    -verbose => $verbose,
	    -storage => $storage,
	    -distroinfo=> $resourceobj->get_dest_distroinfo(),
	    -buildreq => $resourceobj->buildreq,
	    -spec => $spec,
	    );
    }
    return RPM::Source::TransformContainer::TRANSFORMATION_OK;
}

1;
