package RPM::Source::Transformation::Resource::DependencyAnalyzer::Storage;

use strict;
use warnings;
use Carp;
use Data::Dumper;

use RPM::Source::Dependency::Analyzer::Storage;
use RPM::Source::Transformation::Resource;
our @ISA=qw/RPM::Source::Transformation::Resource/;

our $verbose=0;

push @RPM::Source::TransformContainer::RESOURCE_CLASSES, __PACKAGE__;

sub prepare_resource {
    my (undef,undef,undef,$opt,$resourceobj)=@_;
    if ($resourceobj->{'__DependencyAnalyzerStorage'}) {
	#print STDERR "Oops! internal error: dependency_analyzer_storage exists but unprepared\n";
	print STDERR "Oops! internal error: dependency_analyzer_storage exists - destroyed\n";
	print STDERR Data::Dumper::Dumper($resourceobj->{'__DependencyAnalyzerStorage'}),"\n";
	$resourceobj->{'__DependencyAnalyzerStorage'}=undef;
    } else {
	print STDERR "DEBUG: dependency_analyzer_storage: prepared\n" if $verbose>1;
    }
}

sub destroy_resource {
    my (undef,undef,undef,$opt,$resourceobj)=@_;
    $resourceobj->{'__DependencyAnalyzerStorage'}=undef;
    print STDERR "DEBUG: dependency_analyzer_storage: destroyed\n" if $verbose>1;
}

package Source::Shared::ResourceContainer;

sub dependency_analyzer_storage {
    my ($self)=@_;
    my $storage=$self->{'__DependencyAnalyzerStorage'};
    return $storage if $storage;
    $self->{'__DependencyAnalyzerStorage'}=RPM::Source::Dependency::Analyzer::Storage->new();
    print STDERR "DEBUG: dependency_analyzer_storage: created\n" if $RPM::Source::Transformation::Resource::DependencyAnalyzer::Storage::verbose>1;
    return $self->{'__DependencyAnalyzerStorage'};
}

1;
